library(testthat)
library(startR)
context("Number of chunks tests.")
test_that("Single File - Local execution", {


data = Start(dataset = '/esarchive/recon/jma/jra55/monthly_mean/$var$_f6h/$var$_$sdate$$month$.nc',
                 var = 'tas',
                 sdate = '2000',
                 month = indices(1),
                 lat = values(list(0, 14)),
                 lon = values(list(0, 28)),
                 synonims = list(lat = c('lat','latitude'), lon = c('lon','longitude')),
                 return_vars = list(lat = 'dataset', lon = 'dataset'),
                 lat_reorder = Sort(),
                 num_procs = 1, retrieve = FALSE)

################################################################################################
##################################### ONE INPUTS, ONE OUTPUT ###################################
################################################################################################

fun_1 <- function(x) {
  return(x)
}

step_1 <- Step(fun = fun_1,
               target_dims = c('month'), 
               output_dims = c('month'))

wf_1 = AddStep(inputs = data, 
               step_fun = step_1)

# Locally
expect_equal(Compute(workflow = wf_1,
                     chunks = list(lat = 2,lon = 2),
                     threads_load = 2,
                     threads_compute = 4),

# Comprobacion de si hay que poner los chunks de tal forma que el total/n_chunks sea un entero: DA IGUAL (identical = TRUE)
             Compute(workflow = wf_1,
                     chunks = list(lat = 3,lon = 3),
                     threads_load = 2,
                     threads_compute = 4),  check.attributes = FALSE)


# Checking error because of dimension name doesn't exist:
  step_1 <- Step(fun = fun_1,
                 target_dims = c('member'),
                 output_dims = c('member'))
  expect_error(AddStep(inputs = data,
                 step_fun = step_1),
               "The target dimensions required by 'step_fun' for the input 1 are not present in the corresponding provided object in 'inputs'.")
  
  
})


